/*____________________________________________________________________________
        
        Zinf - Zinf Is Not FreeA*p (The Free MP3 Player)

        Portions Copyright (C) 1998-1999 EMusic.com

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
        
        $Id: pmi.cpp,v 1.9 2003/09/16 17:35:05 kgk Exp $
____________________________________________________________________________*/

/* system headers */
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <iostream>
#include <errno.h>
#include <assert.h>

using namespace std;
#include "config.h"

#if HAVE_UNISTD_H
#include <unistd.h>
#elif HAVE_IO_H
#include <io.h>
#else
#error Must have unistd.h or io.h!
#endif // HAVE_UNISTD_H

/* project headers */
#include "pmi.h"
#include "pullbuffer.h"
#include "facontext.h"
#include "log.h"
#include "debug.h"

#define DB printf("%s:%d\n", __FILE__, __LINE__);

PhysicalMediaInput::PhysicalMediaInput(FAContext *context):
                PipelineUnit(context)
{
    m_path = "";
}

PhysicalMediaInput::~PhysicalMediaInput()
{

    m_bExit = true; 
    m_bPause = false;
    m_pSleepSem->Signal();
    m_pPauseSem->Signal();
}

Error PhysicalMediaInput::SetUrl(const std::string& url)
{
    m_path = url;

    return kError_NoErr;
}

Error PhysicalMediaInput::Close(void)
{
    if (m_pOutputBuffer)
       m_pOutputBuffer->Clear();

    return kError_NoErr;
}

/* arch-tag: e233b4b1-bf5d-418f-881d-32f1f124c78e
   (do not change this comment) */
