/*____________________________________________________________________________
	
	Zinf - Zinf Is Not FreeA*p (The Free MP3 Player)

	Portions Copyright (C) 1999 EMusic.com

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
	
	$Id: m3u.h,v 1.6 2003/09/16 17:35:20 kgk Exp $
____________________________________________________________________________*/

#ifndef INCLUDED_M3U_H
#define INCLUDED_M3U_H

#include <string>
#include <vector>

#include <assert.h>

#include "config.h"
#include "errors.h"
#include "facontext.h"

#include "playlistformat.h"
#include "playlist.h"

class M3U : public PlaylistFormat {
 public:
    M3U(FAContext *context);
    virtual ~M3U();

    virtual Error GetSupportedFormats(PlaylistFormatInfo* info, uint32_t index);

    virtual Error readPlaylist(const string& url,
                               std::vector<std::string>& items);

    virtual Error writePlaylist(const string& url,
                                std::vector<std::string>& items);


    virtual Error ReadPlaylist( const char* url, std::vector<PlaylistItem*>* items,
                                PLMCallBackFunction function = NULL,
                                void* cookie = NULL);
    virtual Error WritePlaylist(const char* url, PlaylistFormatInfo* format, 
                                std::vector<PlaylistItem*>* items,
                                PLMCallBackFunction function = NULL,
                                void* cookie = NULL); 
};



#endif // INCLUDED_M3U_H

/* arch-tag: a2bc4d17-fd48-4924-961f-8f2ac3822278
   (do not change this comment) */
