/*____________________________________________________________________________

        Zinf - Zinf Is Not FreeA*p (The Free MP3 Player)

        Portions Copyright (C) 1999-2000 EMusic.com

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

        $Id: musicbrowserui.h,v 1.5 2003/09/16 17:35:28 kgk Exp $
____________________________________________________________________________*/

#ifndef INCLUDED_MUSICBROWSERUI_H_
#define INCLUDED_MUSICBROWSERUI_H_

#include <string>
#include <vector>

#include "config.h"

#include "ui.h"
#include "event.h"
#include "thread.h"
#include "playlist.h"
#include "musiccatalog.h"
#include "gtkmusicbrowser.h"
#include "musicsearchui.h"
#include "introwizard.h"

class FAContext;

class MusicBrowserUI : public UserInterface {
 public:
    MusicBrowserUI(FAContext *);
    virtual Error AcceptEvent(Event *);
    virtual Error Init(int32_t);
    virtual ~MusicBrowserUI();
 
    EventQueue *m_playerEQ;

    void CreateNewEditor(std::string &newPlaylist, bool cd_mode = false);
    void WindowClose(GTKMusicBrowser *oldUI);

    void StartSearch(bool runMain = true, bool intro = false);
  
    void SearchClose(void);
    void WizardClose(void);
	FAContext *GetContext(void) { return m_context; }
 protected:
    FAContext *m_context;

 private:
    bool isVisible;

    Properties *m_propManager;
    int32_t m_startupType;

    bool m_initialized;

    GTKMusicBrowser *mainBrowser;
    std::vector<GTKMusicBrowser *> browserWindows;

    IntroWizardUI *wiz;
    musicsearchUI *searching;
};

#endif

/* arch-tag: e86c69e7-3bf8-4357-9340-553ad6c293be
   (do not change this comment) */
